"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.preloadComponent = void 0;
const path_to_regexp_1 = require("path-to-regexp");
const common_1 = require("../common");
const preloadComponent = async (Routes, base) => {
    for (const route of Routes) {
        const { component, path } = route;
        let pathname = location.pathname;
        if (base) {
            pathname = (0, common_1.normalizePath)(pathname, base);
        }
        if (component.name === 'dynamicComponent' && (0, path_to_regexp_1.pathToRegexp)(path).test(pathname)) {
            route.component = (await component()).default;
        }
    }
    return Routes;
};
exports.preloadComponent = preloadComponent;
//# sourceMappingURL=preload.js.map