"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkForkTs = void 0;
const path_1 = require("path");
const semver_1 = require("semver");
const shelljs_1 = require("shelljs");
const cwd_1 = require("./cwd");
function checkForkTs() {
    try {
        const framework = (0, cwd_1.judgeServerFramework)();
        if (framework === 'ssr-plugin-midway') {
            return;
        }
        const cwd = (0, cwd_1.getCwd)();
        const userCwd = cwd.slice(0, cwd.indexOf('node_modules'));
        const fork = (0, path_1.resolve)(userCwd, './node_modules/fork-ts-checker-webpack-plugin');
        const forkPackage = (0, path_1.resolve)(fork, './package.json');
        const nestCli = (0, path_1.resolve)(userCwd, './node_modules/@nestjs/cli/node_modules');
        const forkVersion = require(forkPackage).version;
        if ((0, semver_1.coerce)(forkVersion).major >= 7 && !(0, cwd_1.accessFileSync)((0, path_1.resolve)(nestCli, './fork-ts-checker-webpack-plugin'))) {
            (0, shelljs_1.mv)(fork, nestCli);
        }
    }
    catch (_error) { }
}
exports.checkForkTs = checkForkTs;
checkForkTs();
//# sourceMappingURL=compatible.js.map