"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getManifest = void 0;
const axios_1 = require("axios");
// 创建一个实例来请求，防止业务代码的 axios 设置了 defaults 配置导致获取 manifest 失败
const instance = axios_1.default.create({
    timeout: 3000,
    proxy: false
});
const getManifest = async (config) => {
    var _a;
    const { isDev, fePort, https, manifestPath, isVite, dynamicFile } = config;
    let manifest = {};
    if ((_a = dynamicFile.configFile) !== null && _a !== void 0 ? _a : !isDev) {
        if (isVite) {
            manifest = require(dynamicFile.assetManifest);
        }
        else {
            // when ssr-common-utils in external whiteList need to be bundle
            manifest = __non_webpack_require__(dynamicFile.assetManifest);
        }
    }
    else if (isDev && !isVite) {
        const res = await instance.get(`${https ? 'https' : 'http'}://0.0.0.0:${fePort}${manifestPath}`);
        manifest = res.data;
    }
    return manifest;
};
exports.getManifest = getManifest;
//# sourceMappingURL=manifest.js.map