import { pathToRegexp } from 'path-to-regexp';
import { normalizePath } from '../common';
const preloadComponent = async (Routes, base) => {
    for (const route of Routes) {
        const { component, path } = route;
        let pathname = location.pathname;
        if (base) {
            pathname = normalizePath(pathname, base);
        }
        if (component.name === 'dynamicComponent' && pathToRegexp(path).test(pathname)) {
            route.component = (await component()).default;
        }
    }
    return Routes;
};
export { preloadComponent };
//# sourceMappingURL=preload.js.map